package com.javacodegeeks.example;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.ExternalResource;
import com.vaadin.server.FontAwesome;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.*;

import javax.servlet.annotation.WebServlet;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

@Theme("mytheme")
public class MyUI extends UI {

    private static final long serialVersionUID = 7132834690301152714L;

    @Override
    protected void init(VaadinRequest vaadinRequest) {

        //VerticalLayout layout = (VerticalLayout) sampleUI();
        //VerticalLayout layout = (VerticalLayout) showLabels();
        //VerticalLayout layout = (VerticalLayout) showLink();
        //VerticalLayout layout = (VerticalLayout) showTextField();
        //VerticalLayout layout = (VerticalLayout) showTextArea();
        //VerticalLayout layout = (VerticalLayout) showDateField();
        //VerticalLayout layout = (VerticalLayout) showPasswordField();
        //VerticalLayout layout = (VerticalLayout) showButton();
        //VerticalLayout layout = (VerticalLayout) showCheckBox();
        VerticalLayout layout = (VerticalLayout) showLists();

        setContent(layout);
    }

    @WebServlet(urlPatterns = "/*", name = "MyUIServlet", asyncSupported = true)
    @VaadinServletConfiguration(ui = MyUI.class, productionMode = false)
    public static class MyUIServlet extends VaadinServlet {
    }

    private Layout sampleUI() {
        final VerticalLayout layout = new VerticalLayout();

        final TextField name = new TextField();
        name.setCaption("Type your name here:");

        Button button = new Button("Click Me");
        button.addClickListener(e -> {
            layout.addComponent(new Label("Thanks " + name.getValue()
                    + ", it works!"));
        });

        layout.addComponents(name, button);
        return layout;
    }

    private Layout showLabels() {
        final VerticalLayout layout = new VerticalLayout();

        Label label = new Label();
        label.setId("LabelID");
        label.setValue("JavaCodeGeeks");
        label.setCaption("Label");
        layout.addComponent(label);
        return layout;
    }

    private Layout showLink() {
        final VerticalLayout layout = new VerticalLayout();

        Link jcgLink = new Link("JavaCodeGeeks",
                new ExternalResource("https://www.javacodegeeks.com/"));
        jcgLink.setTargetName("_blank");
        layout.addComponent(jcgLink);
        return layout;
    }

    private Layout showTextField() {
        final VerticalLayout layout = new VerticalLayout();

        TextField textField = new TextField();
        textField.setIcon(FontAwesome.USER);
        layout.addComponent(textField);
        return layout;
    }

    private Layout showTextArea() {
        final VerticalLayout layout = new VerticalLayout();

        TextArea textArea = new TextArea();
        layout.addComponent(textArea);
        return layout;
    }

    private Layout showDateField() {
        final VerticalLayout layout = new VerticalLayout();

        DateField dateField = new DateField("DateField", LocalDate.now());
        InlineDateField inlineDateField = new InlineDateField();
        layout.addComponent(dateField);
        layout.addComponent(inlineDateField);
        return layout;
    }

    private Layout showPasswordField() {
        final VerticalLayout layout = new VerticalLayout();

        PasswordField passwordField = new PasswordField();
        layout.addComponent(passwordField);
        return layout;
    }

    private Layout showButton() {
        final VerticalLayout layout = new VerticalLayout();

        Button normalButton = new Button("Normal Button");
        layout.addComponent(normalButton);
        return layout;
    }

    private Layout showCheckBox() {
        final VerticalLayout layout = new VerticalLayout();

        CheckBox checkbox = new CheckBox("CheckBox");
        checkbox.setValue(true);
        layout.addComponent(checkbox);
        return layout;
    }

    private Layout showLists() {
        final VerticalLayout layout = new VerticalLayout();

        List<String> numbers = new ArrayList<>();
        numbers.add("One");
        numbers.add("Ten");
        numbers.add("Eleven");

        ComboBox comboBox = new ComboBox("ComboBox");
        comboBox.setItems(numbers);

        layout.addComponent(comboBox);
        return layout;
    }
}
